VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PrinterFlex"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

Option Explicit


Private m_AjustarColumnas As Boolean
Private m_Orientation As e_Orientation
Private m_PiePagina As String
Private m_Encabezado1 As String
Private m_Encabezado2 As String
Private m_ColorEncabezado1 As Long
Private m_ColorEncabezado2 As Long
Private m_ColorPiePagina As Long
Private m_SizePiePagina As Byte
Private m_SizeEncabezado1 As Byte
Private m_SizeEncabezado2 As Byte

Enum e_Orientation
  Vertical = 1
  Horizontal = 2
End Enum


Private WithEvents cTP As clsTablePrint
Attribute cTP.VB_VarHelpID = -1

Private Sub cTP_NewPage(objOutput As Object, TopMarginAlreadySet As Boolean, bCancel As Boolean, ByVal lLastPrintedRow As Long)
    

    If TypeOf objOutput Is Printer Then
        Printer.NewPage
    End If
End Sub



Public Sub ImprimirFlexGrid(FlexGrid As Object)
    On Local Error GoTo errSub

    Set cTP = New clsTablePrint
    
    If m_Orientation = 0 Or m_Orientation = 1 Then
       Printer.Orientation = 1
    Else
       Printer.Orientation = 2
    End If
    
    Encabezados
    
    ImportFlexGrid cTP, FlexGrid, IIf(m_AjustarColumnas, Printer.ScaleWidth - 2 * 567, -1)
    
    cTP.MarginBottom = 567 '567 equals to 1 cm
    cTP.MarginLeft = 567
    cTP.MarginTop = 567
    
    Printer.CurrentY = cTP.MarginTop + Printer.CurrentY
    
    Printer.ForeColor = vbBlack
    cTP.DrawTable Printer
    
      If m_PiePagina <> "" Then
         Printer.CurrentX = 0
         Printer.CurrentY = Printer.CurrentY + 250
         Printer.Line (Printer.CurrentX, Printer.CurrentY)-(Printer.ScaleWidth, Printer.CurrentY)
         
         Printer.CurrentY = Printer.CurrentY + 250
         
         
         If m_SizePiePagina = 0 Then
            Printer.FontSize = 8
         Else
            Printer.FontSize = m_SizePiePagina
         End If
         Printer.ForeColor = m_ColorPiePagina
         
         Printer.Print vbNewLine & m_PiePagina

      End If

    
    
  
    Printer.EndDoc

    Set cTP = Nothing

Exit Sub
errSub:
  MsgBox Err.Description, vbCritical, "Error"
  
End Sub



Private Sub Encabezados()
    
    Printer.Print
    With Printer
      If m_Encabezado1 <> "" Then
         If m_SizeEncabezado1 = 0 Then
            .FontSize = 8
         Else
            .FontSize = m_SizeEncabezado1
         End If
         .ForeColor = m_ColorEncabezado1
         Printer.Print m_Encabezado1
      End If
      If m_Encabezado2 <> "" Then
         If m_SizeEncabezado2 = 0 Then
            .FontSize = 8
         Else
            .FontSize = m_SizeEncabezado2
         End If
         .ForeColor = m_ColorEncabezado2
         Printer.Print m_Encabezado2
      End If
    
    End With
    If m_Encabezado1 <> "" Or m_Encabezado2 <> "" Then
    Printer.CurrentY = Printer.CurrentY + 250
    Printer.Line (Printer.CurrentX, Printer.CurrentY)-(Printer.ScaleWidth, Printer.CurrentY)
    End If
End Sub


Public Property Get AjustarColumnas() As Boolean
AjustarColumnas = m_AjustarColumnas
End Property

Public Property Let AjustarColumnas(ByVal vNewValue As Boolean)
m_AjustarColumnas = vNewValue
End Property


Public Property Get Orientacion() As e_Orientation
Orientacion = m_Orientation
End Property

Public Property Let Orientacion(ByVal vNewValue As e_Orientation)
m_Orientation = vNewValue
End Property

Public Property Get TextEncabezado1() As String
TextEncabezado1 = m_Encabezado1
End Property

Public Property Let TextEncabezado1(ByVal vNewValue As String)
m_Encabezado1 = vNewValue
End Property

Public Property Get TextEncabezado2() As String
TextEncabezado2 = m_Encabezado2
End Property
Public Property Let TextEncabezado2(ByVal vNewValue As String)
m_Encabezado2 = vNewValue
End Property


Public Property Let ColorEncabezado1(ByVal vNewValue As Long)
m_ColorEncabezado1 = vNewValue
End Property
Public Property Get ColorEncabezado1() As Long
ColorEncabezado1 = m_ColorEncabezado1
End Property

Public Property Let ColorEncabezado2(ByVal vNewValue As Long)
m_ColorEncabezado2 = vNewValue
End Property
Public Property Get ColorEncabezado2() As Long
ColorEncabezado2 = m_ColorEncabezado2
End Property

Public Property Let SizeEncabezado1(ByVal vNewValue As Byte)
m_SizeEncabezado1 = vNewValue
End Property
Public Property Get SizeEncabezado1() As Byte
SizeEncabezado1 = m_SizeEncabezado1
End Property
Public Property Let SizeEncabezado2(ByVal vNewValue As Byte)
m_SizeEncabezado2 = vNewValue
End Property
Public Property Get SizeEncabezado2() As Byte
SizeEncabezado2 = m_SizeEncabezado2
End Property

Public Property Get ColorPiePagina() As Long
ColorPiePagina = m_ColorPiePagina
End Property

Public Property Let ColorPiePagina(ByVal vNewValue As Long)
m_ColorPiePagina = vNewValue
End Property

Public Property Get TextPiePagina() As String
TextPiePagina = m_PiePagina
End Property

Public Property Let TextPiePagina(ByVal vNewValue As String)
m_PiePagina = vNewValue
End Property

Public Property Get SizePiePagina() As Byte
SizePiePagina = m_SizePiePagina
End Property

Public Property Let SizePiePagina(ByVal vNewValue As Byte)
m_SizePiePagina = vNewValue
End Property

